* [make-initrd] [PATCH v1 29/41] fork pipeline: bootchain-sh-functions: resolve_target modified
@ 2021-09-24 15:58 Leonid Krivoshein
2021-09-26 12:29 ` Leonid Krivoshein
0 siblings, 1 reply; 2+ messages in thread
From: Leonid Krivoshein @ 2021-09-24 15:58 UTC (permalink / raw)
To: make-initrd
---
.../data/bin/bootchain-sh-functions | 15 ++++++++++++---
1 file changed, 12 insertions(+), 3 deletions(-)
diff --git
a/make-initrd/features/bootchain-core/data/bin/bootchain-sh-functions
b/make-initrd/features/bootchain-core/data/bin/bootchain-sh-functions
index 6a20c4c..35cee1e 100644
--- a/make-initrd/features/bootchain-core/data/bin/bootchain-sh-functions
+++ b/make-initrd/features/bootchain-core/data/bin/bootchain-sh-functions
@@ -24,20 +24,29 @@ get_parameter()
resolve_target()
{
local target="$1"
+
case "${target%%/*}" in
'')
;;
pipe[0-9]|pipe[0-9][0-9]|pipe[0-9][0-9][0-9])
+ target="$mntdir/dst/step${target:4}"
+ ;;
+ step[0-9]|step[0-9][0-9]|step[0-9][0-9][0-9])
target="$mntdir/dst/$target"
;;
*)
if [ -z "${prevdir-}" ]; then
- message "no previous stop to use"
- return
+ message "no previous step results to use with $PROG"
+ return 0
+ fi
+ if [ "$target" = DEVNAME ] && [ -s "$prevdir/DEVNAME" ]; then
+ read -r target <"$prevdir/DEVNAME" ||:
+ else
+ target="$prevdir/${target#/}"
fi
- target="$prevdir/${target#/}"
;;
esac
+
printf '%s' "$target"
}
-- 2.21.0
^ permalink raw reply [flat|nested] 2+ messages in thread
* Re: [make-initrd] [PATCH v1 29/41] fork pipeline: bootchain-sh-functions: resolve_target modified
2021-09-24 15:58 [make-initrd] [PATCH v1 29/41] fork pipeline: bootchain-sh-functions: resolve_target modified Leonid Krivoshein
@ 2021-09-26 12:29 ` Leonid Krivoshein
0 siblings, 0 replies; 2+ messages in thread
From: Leonid Krivoshein @ 2021-09-26 12:29 UTC (permalink / raw)
To: make-initrd
[-- Attachment #1: Type: text/plain, Size: 648 bytes --]
Алексей, привет!
Поздно заметил, что сильно налажал с resolve_target() даже в части
адресации при перегрузке шагов, в следующей итерации исправлю, а пока
прилагаю текущий патч.
Можно ссылаться на результаты пройденных шагов, нумеруя от нуля слева
направо: pipe0[/что-то-там], pipe1[/что-то-ещё], ..., а также в обратную
сторону: step-1[/что-то-там] (предыдущий шаг), step-2[/что-то-ещё]
(перед предыдущим), ..., при этом адресация работает в отношении шагов,
полученных на старте или после перегрузки шагов через bc_nextchain().
Поскольку данный кейс нигде не использовался, заметил слишком поздно,
когда продолжил работать над кодом...
[-- Attachment #2: fix-resolve_target.patch --]
[-- Type: text/x-patch, Size: 2546 bytes --]
commit 3827df94d66c75873c53f0949960a294d7a7f88a
Author: Leonid Krivoshein <klark@altlinux.org>
Date: Sun Sep 26 04:48:04 2021 +0300
fixed resolve_target(), reverse addressation added
diff --git a/bootchain-core/data/bin/bootchain-sh-functions b/bootchain-core/data/bin/bootchain-sh-functions
index 086d698..4f416d2 100644
--- a/bootchain-core/data/bin/bootchain-sh-functions
+++ b/bootchain-core/data/bin/bootchain-sh-functions
@@ -49,25 +49,33 @@ get_parameter()
resolve_target()
{
local target="$1"
+ local where="${target%%/*}"
+ local n="${#where}"
- case "${target%%/*}" in
+ target="${target:$n}"
+
+ case "$where" in
'')
;;
pipe[0-9]|pipe[0-9][0-9]|pipe[0-9][0-9][0-9])
- target="$mntdir/dst/step${target:4}"
+ n="$(( ${basestep:-0} + ${where:4} ))"
+ [ ! -d "$mntdir/dst/step$n" ] && return 0 ||
+ target="$mntdir/dst/step${n}${target}"
;;
- step[0-9]|step[0-9][0-9]|step[0-9][0-9][0-9])
- target="$mntdir/dst/$target"
+ step-[1-9]|step-[1-9][0-9]|step-[1-9][0-9][0-9])
+ n="$(( ${stepnum:-0} - ${where:5} ))"
+ [ "${basestep:-0}" -le "$n" ] && [ -d "$mntdir/dst/step$n" ] &&
+ target="$mntdir/dst/step${n}${target}" || return 0
;;
*)
if [ -z "${prevdir-}" ]; then
- message "no previous step results to use with $PROG"
+ message "no previous step results to use with $name"
return 0
fi
- if [ "$target" = DEVNAME ] && [ -s "$prevdir/DEVNAME" ]; then
- read -r target <"$prevdir/DEVNAME" ||:
+ if [ "$where" = DEVNAME ] && [ -s "$prevdir/DEVNAME" ]; then
+ read -r target <"$prevdir/DEVNAME" 2>/dev/null ||:
else
- target="$prevdir/${target#/}"
+ target="$prevdir/${where#/}${target}"
fi
;;
esac
diff --git a/bootchain-core/data/sbin/bootchain-loop b/bootchain-core/data/sbin/bootchain-loop
index 1cf00d3..59c2ac7 100755
--- a/bootchain-core/data/sbin/bootchain-loop
+++ b/bootchain-core/data/sbin/bootchain-loop
@@ -6,6 +6,7 @@ bcretry="${bcretry:-1}"
stepnum="${stepnum:-0}"
chainsteps="${chainsteps-}"
prevdir="${prevdir-}"
+basestep="$stepnum"
BC_IM_supported=
@@ -83,7 +84,8 @@ while [ -n "$chainsteps" ]; do
else
message "[$callnum] Handler: $exe"
- export name callnum datadir destdir prevdir
+ export name callnum datadir destdir
+ export basestep stepnum prevdir
for try in 1 2 3 4 5; do
[ -z "$BC_DEBUG" ] ||
@@ -128,6 +130,7 @@ while [ -n "$chainsteps" ]; do
debug "chain will be reloaded by $BC_NEXTCHAIN:"
fdump "$BC_NEXTCHAIN"
. "$BC_NEXTCHAIN"
+ basestep="$stepnum"
run rm -f -- "$BC_NEXTCHAIN"
fi
^ permalink raw reply [flat|nested] 2+ messages in thread
end of thread, other threads:[~2021-09-26 12:29 UTC | newest]
Thread overview: 2+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2021-09-24 15:58 [make-initrd] [PATCH v1 29/41] fork pipeline: bootchain-sh-functions: resolve_target modified Leonid Krivoshein
2021-09-26 12:29 ` Leonid Krivoshein
Make-initrd development discussion
This inbox may be cloned and mirrored by anyone:
git clone --mirror http://lore.altlinux.org/make-initrd/0 make-initrd/git/0.git
# If you have public-inbox 1.1+ installed, you may
# initialize and index your mirror using the following commands:
public-inbox-init -V2 make-initrd make-initrd/ http://lore.altlinux.org/make-initrd \
make-initrd@lists.altlinux.org make-initrd@lists.altlinux.ru make-initrd@lists.altlinux.com
public-inbox-index make-initrd
Example config snippet for mirrors.
Newsgroup available over NNTP:
nntp://lore.altlinux.org/org.altlinux.lists.make-initrd
AGPL code for this site: git clone https://public-inbox.org/public-inbox.git